#include <iostream>

namespace MyLib {
class MyObj {};
void swap(MyObj& /*a*/, MyObj& /*b*/) {
	std::cout << "calling MyLib::swap\n";
}
} // namespace MyLib

void f1() {
	std::cout << "f1\n";
	// uses std::swap
	MyLib::MyObj a, b;
	std::swap(a, b);
}

void f2() {
	std::cout << "f2\n";
	// uses MyLib::swap
	// but what if there were no such function?
	MyLib::MyObj a, b;
	swap(a, b);
}

void f3() {
	std::cout << "f3\n";
	// uses MyLib::swap if it exists
	// otherwise uses std::swap
	using std::swap;
	MyLib::MyObj a, b;
	swap(a, b);
}

int main() {
	f1();
	f2();
	f3();
}
