#include <iostream>
#include <stdexcept>

class X {
	int id;

public:
	X(int id)
	    : id(id) { std::cout << "X(" << id << ")\n"; }
	~X() { std::cout << "~X() with id = " << id << '\n'; }
};

void foo() {
	X x(3);
	std::cout << "inside foo, before exception\n";
	throw std::runtime_error("Something bad happened!");
	std::cout << "inside foo, after exception\n";
}

void boo() {
	X x(2);
	foo();
}

int main() {
	X x(0);
	try {
		X x(1);
		std::cout << "main before foo\n";
		boo();
		std::cout << "main after foo\n";
	} catch (std::runtime_error& ex) {
		std::cout << "Runtime error: " << ex.what() << "\n";
	}
	std::cout << "main after try-catch\n";
}
