#include <iostream>
#include <memory>
#include <stdexcept>

int main() {
	const size_t SIZE = 1000000000000ull;
	try {
		auto array = std::make_unique<int[]>(SIZE);
		for (size_t i = 0; i < SIZE; ++i) {
			array[i] = i * i;
		}
	} catch (std::bad_alloc& ex) {
		std::cerr << "Failed to allocate memory.\n";
		std::cerr << ex.what() << '\n';
	}
}
