#include <cctype>
#include <iostream>
#include <stdexcept>

class WrongNameException : public std::invalid_argument {
	std::string name;

public:
	WrongNameException(const std::string& reason, const std::string& n)
	    : std::invalid_argument(reason)
	    , name(n) {}
	const std::string& getName() const { return name; }
};

class Person {
	std::string name;
	static bool isValidName(const std::string& name) {
		return !name.empty() && std::isupper(name[0]);
	}

public:
	Person(const std::string& n)
	    : name(n) {
		if (!isValidName(name)) {
			throw WrongNameException("invalid name", name);
		}
	}
};

int main() {
	// what is wrong here? (hint: do not forget to read warnings)
	try {
		Person p("john");
	} catch (std::invalid_argument& ex) {
		std::cout << ex.what() << '\n';
	} catch (WrongNameException& ex) {
		std::cout << ex.what() << ": " << ex.getName() << '\n';
	}
}
