#include <iostream>
#include <stdexcept>

class X {
public:
	X() { std::cout << "X()\n"; }
	~X() { std::cout << "~X()\n"; }
};

class A {
public:
	A() { std::cout << "A()\n"; }
	~A() { std::cout << "~A()\n"; }
};

class Y : public X {
	int id;
	A a;

public:
	Y(int id)
	    : id(id) {
		std::cout << "Y()\n";
		if (id < 0) {
			throw std::invalid_argument("Y: negative id");
		}
	}
	~Y() { std::cout << "~Y()\n"; }
};

int main() {
	try {
		Y y(-7);
	} catch (std::exception& ex) {
		std::cout << ex.what() << '\n';
	};
}
