#include <iostream>
#include <stdexcept>

class Person {
	std::string name;

public:
	Person(const std::string& n)
	    : name(n) {
		if (name.empty()) {
			throw std::invalid_argument("Person: empty name");
		}
	}
};

class Teacher : public Person {
	Person& departmentBoss;

public:
	Teacher(const std::string& name, Person& boss) try
	    : Person(name)
	    , departmentBoss(boss) {
	} catch (std::exception& ex) {
		std::cerr << "Teacher constructor failed: " << ex.what() << '\n';
		// implicit throw; here
	}
};

int main() {
	try {
		Person bb("Big Boss");
		Teacher somebody("", bb);
	} catch (std::exception& ex) {
		std::cerr << "Exception: " << ex.what() << '\n';
	}
}
